Bug 1468383 - Review Request: python-easyargs - Making argument parsing easy
Review Request: python-easyargs - Making argument parsing easy
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Robert-André Mauchin
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-06 18:02 EDT by Carl George
Modified: 2017-08-17 15:25 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-17 15:25:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zebob.m: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Carl George 2017-07-06 18:02:18 EDT
Spec URL: https://carl.george.computer/review/python-easyargs.spec
SRPM URL: https://carl.george.computer/review/python-easyargs-0.9.4-1.fc27.src.rpm
Description:
A project designed to make command line argument parsing easy.  There are many
ways to create a command line parser in python: argparse, docopt, click.  These
are all great options, but require quite a lot of configuration and sometimes
you just need a function to be called.  Enter easyargs.  Define the function
that you want to be called, decorate it and let easyargs work out the command
line.
Fedora Account System Username: carlwgeorge
Scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=20370080
Comment 1 Carl George 2017-08-02 11:24:04 EDT
Built in COPR for testing.

https://copr.fedorainfracloud.org/coprs/carlwgeorge/python-easyargs/
Comment 2 Scott Talbert 2017-08-11 21:19:57 EDT
Your spec and srpm are returning 403 forbidden.
Comment 3 Carl George 2017-08-11 22:03:19 EDT
Sorry about that, I just updated that server from F25 to F26 and now I'm having selinux file context issues serving those files with Caddy.  I copied them over to fedorapeople.org.

https://carlwgeorge.fedorapeople.org/python-easyargs.spec
https://carlwgeorge.fedorapeople.org/python-easyargs-0.9.4-1.fc27.src.rpm
Comment 4 Robert-André Mauchin 2017-08-17 06:20:46 EDT
Hello,

 - Please use the macros %{py2_dist/%{py3_dist for your BR and R. See https://fedoraproject.org/wiki/Packaging:Python#Requires_and_BuildRequires_with_standardized_names

BuildRequires: %{py2_dist setuptools}
%if %{with tests}
BuildRequires: %{py2_dist pytest}
BuildRequires: %{py2_dist mock}
BuildRequires: %{py2_dist six}
Requires: %{py2_dist six}
%endif

 - You should probably define a global macro containing the description, instead of repeating it 3 times:

%global desc A project designed to make command line argument parsing easy.  There are many\
ways to create a command line parser in python: argparse, docopt, click.  These\
are all great options, but require quite a lot of configuration and sometimes\
you just need a function to be called.  Enter easyargs.  Define the function\
that you want to be called, decorate it and let easyargs work out the command\
line.

 - There's a little difference between your Requires for python2 and python3: for python2 the require for six is inside the test condition, for python3, you require six outside of the test condition. Is this normal?


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 16 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/python-easyargs/review-python-
     easyargs/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-easyargs , python3-easyargs
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-easyargs-0.9.4-1.fc27.noarch.rpm
          python3-easyargs-0.9.4-1.fc27.noarch.rpm
          python-easyargs-0.9.4-1.fc27.src.rpm
python2-easyargs.noarch: W: spelling-error %description -l en_US argparse -> sparse, parsec, parse
python2-easyargs.noarch: W: spelling-error %description -l en_US docopt -> doc opt, doc-opt, Coptic
python3-easyargs.noarch: W: spelling-error %description -l en_US argparse -> sparse, parsec, parse
python3-easyargs.noarch: W: spelling-error %description -l en_US docopt -> doc opt, doc-opt, Coptic
python-easyargs.src: W: spelling-error %description -l en_US argparse -> sparse, parsec, parse
python-easyargs.src: W: spelling-error %description -l en_US docopt -> doc opt, doc-opt, Coptic
3 packages and 0 specfiles checked; 0 errors, 6 warnings.
Comment 5 Carl George 2017-08-17 10:15:02 EDT
Using the py2_dist/py3_dist macros would prevent me from having an identical spec file for Fedora and EPEL, since stock RHEL packages don't provide "python2dist(<NAME>)".  It seems like a useful macro, but until I can use it everywhere, no thanks.

I've seen the description macro approach you've mentioned, but I'm honestly not a fan of it.  Is it a blocker?

Thanks for catching that misplaced six requirement, it was an oversight on my part.  It's fixed now.

https://carlwgeorge.fedorapeople.org/python-easyargs.spec
https://carlwgeorge.fedorapeople.org/python-easyargs-0.9.4-2.fc27.src.rpm
Comment 6 Robert-André Mauchin 2017-08-17 10:53:00 EDT
>Using the py2_dist/py3_dist macros would prevent me from having an identical spec file for Fedora and EPEL, since stock RHEL packages don't provide "python2dist(<NAME>)".

Okay

>Is it a blocker?

No

Everything is okay. Package accepted.

BTW, thanks for your ripgrep COPR package.
Comment 7 Carl George 2017-08-17 11:28:38 EDT
No problem at all, ripgrep is very useful.  I had submitted it for review previously, but the Rust SIG wants to package it using ranged dependencies, which I don't believe is available ina released version of RPM yet.  Even when it is (F28?), it is doubtful to ever be available on RHEL, so I'll keep that COPR going everywhere it makes sense.

Thanks for the review!
Comment 8 Gwyn Ciesla 2017-08-17 11:51:00 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-easyargs

Note You need to log in before you can comment on or make changes to this bug.